proyecto-taller-info/config/routes.rb
Rails.application.routes.draw do

  resources :people
  devise_for :users

  resources :users
  resources :companies
  resources :projects
  resources :legal_agents

  get '' => 'static_pages#home'
  get '/users/annul/:id' => 'users#annul'
  get '/users/activate/:id' => 'users#activate'
  get 'error' => 'static_pages#error'
  post '/createuser' => 'users#create'

end

proyecto-taller-info/app/models/company.rb
class Company < ActiveRecord::Base
	has_many :legal_agents, :dependent => :delete_all

	validates :name, :presence => {:message => ' no debe dejarse en blanco.'}
	validates :name, uniqueness: {message: ' ya existe, no se debe duplicar'}
	validates :principal_activity, :presence => {:message => ' no debe dejarse en blanco.'}
	validates :nit, :presence => {:message => ' no debe dejarse en blanco.'}
	validates :nit, uniqueness: {message: ' ya existe, no se debe duplicar'}
	validates :nit, numericality: { only_integer: true, message: ' debe ser un numero' }
	validates :address, :presence => {:message => ' no debe dejarse en blanco.'} 
	validates :canton, :presence => {:message => '  no debe dejarse en blanco.'} 
	validates :province, :presence => {:message => ' no debe dejarse en blanco.'} 
	validates :departament, :presence => {:message => ' no debe dejarse en blanco.'} 
	validates :phones, :presence => {:message => ' no debe dejarse en blanco.'} 
	validates :phones, numericality: { only_integer: true, message: ' debe ser un numero' }
	#validates :fax, :presence => {:message => '  (Fax) no debe dejarse en blanco.'} 
	validates :mailbox, :presence => {:message => ' no debe dejarse en blanco.'}

	def self.search(search)
		where("name LIKE :search ", search:"%#{search}%")
	end

end

proyecto-taller-info/app/controllers/companies_controller.rb
class CompaniesController < ApplicationController
  before_action :set_company, only: [:show, :edit, :update, :destroy]

  # GET /companies
  # GET /companies.json
  def index
    @companies = Company.all
     if params[:search]
        @companies = Company.search(params[:search]).order("created_at DESC")
      else
        @companies = Company.all.order('created_at ASC')
    end
  end

  # GET /companies/1
  # GET /companies/1.json
  def show
  end

  # GET /companies/new
  def new
    @company = Company.new
  end

  # GET /companies/1/edit
  def edit
  end

  # POST /companies
  # POST /companies.json
  def create
    @company = Company.new(company_params)

    respond_to do |format|
      if @company.save
        format.html { redirect_to @company, notice: 'Compania registrada exitosamente' }
        format.json { render :show, status: :created, location: @company }
      else
        format.html { render :new }
        format.json { render json: @company.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /companies/1
  # PATCH/PUT /companies/1.json
  def update
    respond_to do |format|
      if @company.update(company_params)
        format.html { redirect_to @company, notice: 'Compania actualizada exitosamente' }
        format.json { render :show, status: :ok, location: @company }
      else
        format.html { render :edit }
        format.json { render json: @company.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /companies/1
  # DELETE /companies/1.json
  def destroy
    @company.destroy
    respond_to do |format|
      format.html { redirect_to companies_url, notice: 'Compañia eliminada' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_company
      @company = Company.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def company_params
      params.require(:company).permit(:name, :principal_activity, :nit, :address, :canton, :province, :departament, :phones, :fax, :mailbox)
    end
end

proyecto-taller-info/app/helpers/companies_helper.rb
module CompaniesHelper
end

proyecto-taller-info/app/views/companies/_form.html.erb
<%= form_for(@company) do |f| %>
  <% if @company.errors.any? %>
    <div class="col-md-3"></div>
    <div class="col-md-6">
      
      <div class="panel panel-danger">
        <div class="panel-heading">Errores al registrar compañia</div>
          <ul class="list-group">
            <% @company.errors.full_messages.each do |message| %>
              <li class='list-group-item'><%= message %></li>
            <% end %>
          </ul>
      </div>
    </div>
  <% end %>
<br>

<div class="row">
  <div class="col-md-6">  
    <div class="field">
      <label>Nombre</label><br>
      <%= f.text_field :name, :class => 'form-control'%>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <div class="field">
      <label>Actividad principal</label><br>
      <%= f.text_field :principal_activity, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <div class="field">
      <label>NIT</label><br>
      <%= f.number_field :nit, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <div class="field">
      <label>Direccion</label><br>
      <%= f.text_field :address, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <div class="field">
      <label>Canton</label><br>
      <%= f.text_field :canton, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
  </div>

  <div class="col-md-6">
    <div class="field">
      <label>Provincia</label><br>
      <%= f.text_field :province, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <div class="field">
      <label>Departamento</label><br>
      <%= f.text_field :departament, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <div class="field">
      <label>Telefono</label><br>
      <%= f.text_field :phones, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <!--<div class="field">-->
      <!--<%= f.label :fax %><br>-->
      <!--<%= f.text_field :fax, :class => 'form-control' %>-->
    <!--</div><br>-->
    <div class="field">
      <label>Codigo Postal</label><br>
      <%= f.text_field :mailbox, :class => 'form-control' %>
      <span class="fa fa-info-circle errspan"></span>
    </div><br>
    <br><p>* Todos los campos son obligatorios.</p>
  </div><br>
      

  </div><br>

  <div class="row center actions">
    <%= f.submit 'Registrar', class: 'btn btn-default ' %>
  </div>
<% end %>

proyecto-taller-info/app/views/companies/edit.html.erb
<h1>Editar compañia</h1>

<%= render 'form' %>

<!--<%= link_to 'Show', @company %> |
<%= link_to 'Back', companies_path %>-->

proyecto-taller-info/app/views/companies/index.html.erb
<p id="notice"><%= notice %></p>

<div class="row">
  <div class="col-md-7">
    <h1>Listado de compañias </h1>
    <br>
  </div>
  <div class="col-md-5">
      <%= render :partial => 'companies/search' %>
      <div class="form-inline">
        <br>
        <%= form_tag(companies_path, :method => "get", id: "search-form") do %>
          <%= text_field_tag :search, params[:search], placeholder: "Buscar compañia", :class => 'form-control'%>
        <%= submit_tag 'Buscar', :class=>'btn btn-default' %>
      </div>
    <% end %>
  </div>
</div>

<% if @companies.present? %>
  <br>
  <h4>Haga click en el nombre de la compania para ver detalles</h4>
  <br>
  <table class="table table-striped">
    <thead>
      <tr>
        <th>Nombre</th>
        <th>Actividad Principal </th>
        <th>NIT</th>
        <th>Direccion</th>
        <!--<th>Canton</th>
        <th>Provincia</th>
        <th>Departamento</th>-->
        <th>Telefono</th>
        <!--<th>Fax</th>
        <th>Buzon</th>
        <th colspan="3"></th>-->
      </tr>
    </thead>

    <tbody>
      <% @companies.each do |company| %>
        <tr>
          <td><%=link_to company.name, company  %></td>
          <td><%= company.principal_activity %></td>
          <td><%= company.nit %></td>
          <td><%= company.address %></td>
       <!--   <td><%= company.canton %></td>
          <td><%= company.province %></td>
          <td><%= company.departament %></td>-->
          <td><%= company.phones %></td>
          <!--<td><%= company.fax %></td>
          <td><%= company.mailbox %></td>
          <td><%= link_to 'Show', company %></td>-->
          <td><%= link_to 'Editar', edit_company_path(company) %></td>
          <td><%= link_to 'Eliminar', company, method: :delete, data: { confirm: 'Confirmacion' } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
<%else%>
  <% if params[:search] %>
    <h4>Su busqueda no generó resultados</h4>
  <%else%>
    <h4>No existen Compañias registradas este momento</h4>
  <%end%>
<%end%>
<br>

<!--<%= link_to 'New Company', new_company_path %>-->

proyecto-taller-info/app/views/companies/new.html.erb
<h1>Nueva Compania</h1>

  <%= render 'form' %>

<!--<%= link_to 'Back', companies_path %>-->

proyecto-taller-info/app/views/companies/show.html.erb
<h2>Compañia</h2>
<br>
<p id="notice"><%= notice %></p>

<div class='jumbotron'>
  <table class='table'>
    <tr>
      <td> <strong>Nombre</strong> </td>
      <td> <%= @company.name %> </td>

      <td> <strong>Actividad principal</strong> </td>
      <td> <%= @company.principal_activity %> </td>
    </tr> 

    <tr>
      <td> <strong>NIT</strong> </td>
      <td> <%= @company.nit %> </td>

      <td> <strong>Direccion</strong> </td>
      <td> <%= @company.address %> </td>
    </tr>

    <tr>
      <td> <strong>Canton</strong> </td>
      <td> <%= @company.canton %> </td>

      <td> <strong>Provincia</strong> </td>
      <td> <%= @company.province %> </td>
    </tr>
      <td> <strong>Departamento</strong> </td>
      <td> <%= @company.departament %> </td>

      <td> <strong>Telefono</strong> </td>
      <td> <%= @company.phones %> </td>

      <!--<td> <strong>Fax</strong>   </td>
        <td> <%= @company.fax %> </td>-->
    <tr>
      <td> <strong>Buzon de correo</strong>
      </td>
      <td> <%= @company.mailbox %> </td>
      <td> </td>
      <td> </td>
    </tr>
  </table>
</div>

<%= link_to 'Editar compañia', edit_company_path(@company), :class=>'btn btn-primary' %> 
<%= link_to 'Atras', companies_path, :class=>'btn btn-default'%>